package com.sf.javase.day11.api;

import org.junit.jupiter.api.Test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 常用Api练习
 * api   =   Application   program  interface
 */
public class T {
    @Test
    public void t1(){
        StringBuilder stringBuilder = new StringBuilder();
        StringBuilder stringBuilder1 = new StringBuilder("qweryi");
//        StringBuilder delete = stringBuilder1.delete(2, 3);
        StringBuilder append = stringBuilder.append(stringBuilder1);
        System.out.println(stringBuilder);
        System.out.println(stringBuilder1);
        StringBuilder delete = append.delete(2, 3);
        System.out.println(delete);
        System.out.println(stringBuilder);
        System.out.println(stringBuilder1);

//        System.out.println(delete);
//        stringBuilder.append("dhyriutyiooi");
//        System.out.println(stringBuilder);
//        StringBuilder delete = stringBuilder.delete(2, 4);
//        System.out.println(delete);
//        StringBuilder str = stringBuilder.deleteCharAt(2);
////        System.out.println(str);
//        StringBuilder a = stringBuilder.replace(2, 8, "AAAAAAAAAAAAAA");
//        System.out.println(a);
//        StringBuilder qqq = stringBuilder.insert(1, "QQQ");
//        System.out.println(qqq);
//        StringBuilder reverse = qqq.reverse();
//        System.out.println(reverse);
    }

    /**
     * 线程安全
     *
     */
    @Test
    public void t2(){
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("qwe");
    }

    /**
     * 效率测试
     */
    @Test
    public void t3(){
     long start = 0L;
     long end  = 0L;
     String str = "";
     StringBuffer buffer = new StringBuffer("");
     StringBuilder builder = new StringBuilder("");
     //获取当前时间
        start= System.currentTimeMillis();
        for (int i = 200000; i > 0; i--) {
            buffer.append(String.valueOf(i));
        }
        end= System.currentTimeMillis();
        System.out.println("buffer   = "+(end - start));

        start= System.currentTimeMillis();
        for (int i = 200000; i > 0; i--) {
            builder.append(String.valueOf(i));
        }
        end= System.currentTimeMillis();
        System.out.println("builder   = "+(end - start));

        start= System.currentTimeMillis();
        for (int i = 2000; i > 0; i--) {
           str += String.valueOf(i);
        }
        end= System.currentTimeMillis();
        System.out.println("String   = "+(end - start));
    }


    /**
     * 时间API
     */
    @Test
    public void t4(){
        long millis = System.currentTimeMillis();
        Date date = new Date();
        System.out.println(date);
        long millis1 = System.currentTimeMillis();
        Date date1 = new Date(millis1);
        System.out.println(date1);

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");
        String dateStr = simpleDateFormat.format(date);
        System.out.println(dateStr);
    }

    @Test
    public void t5() throws ParseException {
       String str = "2024年07月29日 16时25分04秒";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy年MM月dd日 HH时mm分ss秒");
        Date parse = sdf.parse(str);
        System.out.println(parse);
    }

    @Test
    public void t6(){

    }
}
